#include "mbed.h"
#define nb_data 14000  // unsigned short : 16 bits  LPC1768 : 32 K.Octets
#define periode_acquis 95  // periode entre 2 aquisitions en s
#define size_buf_moy 100    // attention  l'overflow de somme
#define delais_acquis 50     // delais en seconde suite  une acquisition  refaire
#define delais_rejet 100     // delais en seconde suite  une acquisition  refaire
#define seuil_refaire 2
LocalFileSystem local("local");
Serial pc(USBTX, USBRX);
AnalogIn adc(p15);
unsigned short buffer[nb_data]; 
unsigned short buf_moy[size_buf_moy]; // buffer tournant
unsigned long long somme;
char j;
       
int main() {
    pc.printf("Depart acquisition!\n");    
    wait(0.5);    
    // remplissage tableau  moyenner
    somme=0;
    for (j=0; j<size_buf_moy; j++)
        {
        buf_moy[j]=adc.read_u16();
        somme+=buf_moy[j];
        wait_us(delais_acquis);
        }
    j=0;
    // acquisition
    for (int i=0; i<nb_data; i++)
        { 
        somme-=buf_moy[j];
        buf_moy[j]=adc.read_u16();
        // si parasite: rejet
        if (abs(buf_moy[j]-buffer[i-1])>seuil_refaire) 
            { 
            wait_us(delais_rejet);
            buf_moy[j]=adc.read_u16(); 
            //pc.printf("1ere pass \n");            
            }
        else if (abs(buf_moy[j]-buffer[i-1])>seuil_refaire) 
            { 
            wait_us(delais_rejet);
            buf_moy[j]=adc.read_u16(); 
            pc.printf("2e pass \n");
            }
        else if (abs(buf_moy[j]-buffer[i-1])>seuil_refaire) 
            { 
            wait_us(delais_rejet);
            buf_moy[j]=adc.read_u16(); 
            pc.printf("3e pass \n");
            }
        somme+=buf_moy[j];
        j++;
        if (j==size_buf_moy) j=0;       
        buffer[i]= (somme / size_buf_moy);  
        wait_us(delais_acquis);
        }    
    pc.printf("Sauvegarde, Opening File...\n"); // Drive should be marked as removed
    FILE *fp = fopen("/local/adc.csv", "w");
    if(!fp) {
        pc.printf("File /local/adc.csv could not be opened!\n");
        exit(1);
    }    
    for (int i=0; i<nb_data; i++)
        {
        fprintf(fp,"%i\n",buffer[i]);
        }     
    pc.printf("Closing File..., fini!\n");
    fclose(fp);
}
/*
Sous windows :
Excel est associ au .CSV donc le fichier batch suivant :
Rem -------------------------------
start f:\adc.csv 
start D:\document\travail\20-podet\logiciel_emb\pc_graph_adc\graph_f_adc_csv.xls
rem ---------------------------------
permet
-	louverture du fichier stock sur le clef USB, mapp disque  f :  sous windows
-	louverture dun 2e fichier excel,  graph_f_adc_csv.xls  affichant un graphique. 
        Le graphique pointe sa plage de donne sur le fichier ouvert, 
        1ere colonne :  =ADC.CSV!$A$1:$A$14001 
De plus, une case excel ralise la moyenne des data: =MOYENNE(ADC.CSV!$A:$A)
et une 2e fait lcart type: =ECARTYPE(ADC.CSV!$A:$A)

*/
